import java.awt.* ;
import java.awt.event.* ;
import java.lang.* ;

//
//  ʡܡ: οʹԤϡΥ饹Ǽ
//  BlInnerBoard:
//
class BlInnerBoard extends Panel
	implements MouseListener, MouseMotionListener, Runnable
{
    // Thread myThread = null ;
    Color  myColor ;
    int width, height, unit ;
    Ball[] balls ;
    MotionManager mm ;
    int myBall ;
    int mx, my ;
    int px, py ;
    EnergyBar  ebar ;
    CuePointer cuep ;
    Label[] player ;
    Label[] score ;
    int[]   iScore ;

    public BlInnerBoard (int width, int height, int unit) {
	super () ;

	int i ;
	this.width  = width ;
	this.height = height ;

	WallInfo wi = new WallInfo (0.0, (double)width,
				    0.0, (double)height,
				    GameParam.ballRadius) ;
	Ball.initStatic (GameParam.ballRadius) ;
	Ball.setMotionParams (GameParam.velAccel,
			      GameParam.vRotAccel,
			      GameParam.hRotAccel) ;
	balls = new Ball[4] ;
	balls[0] = new Ball (Color.yellow, unit * 1, height/2) ; 
	balls[1] = new Ball (Color.red,    unit * 2, height/2) ;
	balls[2] = new Ball (Color.red,    unit * 6, height/2) ;
	balls[3] = new Ball (Color.white,  unit * 7, height/2) ;

	mm = new MotionManager (balls, wi) ;
	myBall = 0 ;

	this.unit = unit ;
	setSize (width, height) ;
	myColor = new Color (0, 110, 0) ;
	setBackground (myColor) ;
	addMouseListener (this) ;
	addMouseMotionListener (this) ;
	iScore = new int[2] ;
	iScore[0] = iScore[1] = 0 ;

	// myThread = new Thread (this) ;
	// myThread.start() ;
	// myThread.suspend() ;
    }
    public void notifyEnergyBar (EnergyBar eb) {
	ebar = eb ;
    }
    public void notifyCuePointer (CuePointer qp) {
	cuep = qp ;
    }
    public void notifyLabel (Label[] player, Label[] score) {
	this.player = player ;
	this.score  = score ;
    }
    public void paint (Graphics g) {
	int i ;
	for (i = 0 ; i < balls.length ; i++) {
	    balls[i].draw (g) ;
	}
    }
    // Move balls and display motion
    public int doAction () {
	int colbits = 0 ;
	int cousions ;
	int dispcnt = 0 ;
	int cnt ;

	// myThread.resume() ;
	for (;;) {
	    mm.moveBalls () ;
	    colbits  |= mm.collisionCheck (myBall) ;
	    cousions = mm.wallCheck () ;
	    if (dispcnt >= GameParam.dispInterval) {
		moveAndShowBalls () ;
		dispcnt = 0 ;
	    } else
		dispcnt++ ;
	    if (mm.disAcceleration()) {
		break ;
	    }
	    if (GameParam.sleepTime > 0) {
		try {
		    Thread.sleep (GameParam.sleepTime, 0) ;
		} catch (InterruptedException e) {} ;
	    }
	}
	mm.stopBalls () ;
	// myThread.suspend() ;

	cnt = countBits (colbits) ;
	if (cnt >= 2) {
	    int idx = playerIndex() ;
	    iScore[idx]++ ;
	    score[idx].setText (Integer.toString(iScore[idx])) ;
	} else {
	    int idx = playerIndex () ;

	    player[idx].setBackground (Color.white) ;
	    score[idx].setBackground (Color.white) ;

	    myBall = (myBall == 0) ? 3 : 0 ;
	    idx = playerIndex () ;

	    player[idx].setBackground (Color.orange) ;
	    score[idx].setBackground (Color.orange) ;
	}
	return myBall ;
    }
    int playerIndex () {
	return (myBall == 0) ? 0 : 1 ;
    }
    int countBits (int bits) {
	int i ;
	int cnt = 0 ;
	
	for (i = 0 ; i < 4 ; i++) {
	    if ((bits & (1 << i)) != 0)
		cnt++ ;
	}
	return cnt ;
    }
    void displayBalls () {
	Graphics g = getGraphics () ;
	int i ;
	
	for (i = 0 ; i < balls.length ; i++)
	    balls[i].draw (g) ;
    }
    void moveAndShowBalls () {
	Graphics g = getGraphics () ;
	int i ;

	for (i = 0 ; i < balls.length ; i++)
	    balls[i].moveAndDraw (g, myColor) ;
    }
    public void mouseClicked (MouseEvent e) {}
    public void mouseEntered (MouseEvent e) {
	Point p ;
	Graphics g = getGraphics () ;

	p = balls[myBall].getCenter () ;
	
	mx = e.getX() ;
	my = e.getY() ;
	px = p.x ;
	py = p.y ;
	
	g.setXORMode (Color.white) ;
	g.drawLine (px, py, mx, my) ;
    }
    public void mouseExited  (MouseEvent e) {
	Graphics g = getGraphics () ;

	g.setXORMode (Color.white) ;
	g.drawLine (px, py, mx, my) ;
    }
    public void mouseReleased (MouseEvent e) {}
    public void mousePressed (MouseEvent e) {
	Graphics g = getGraphics () ;
	g.setXORMode (Color.white) ;
	g.drawLine (px, py, mx, my) ;

	double dir = Ball.xyDirection ((double)(mx - px), (double)(my - py)) ;
	double e_ratio = ebar.getValue() / ebar.getMax() ;

	//
	// ưͥ륮ϡ 1/2*m*v*v ʤΤǡ®٤ϡͥ륮
	// ʿ㤹롣ǡʲμ(䤷)
	//
	double vel  = Math.sqrt(e_ratio) * GameParam.maxVelocity ;
	double vrot = Math.sqrt(e_ratio) * cuep.yRatio() * GameParam.vRotMax ;
	double hrot = Math.sqrt(e_ratio) * cuep.xRatio() * GameParam.hRotMax ; 

	balls[myBall].setParameter (dir, vel, hrot, vrot) ;
	myBall = doAction () ;
	mx = my = -1 ;
    }
    public void mouseDragged (MouseEvent e) {}
    public void mouseMoved   (MouseEvent e) {
	Graphics g = getGraphics () ;
	if (mx >= 0) {  
	    g.setXORMode (Color.white) ;
	    g.drawLine (px, py, mx, my) ;
	    mx = e.getX() ;
	    my = e.getY() ;
	    g.drawLine (px, py, mx, my) ;
	} else {
	    Point p ;

	    mx = e.getX () ;
	    my = e.getY () ;
	    p  = balls[myBall].getCenter() ;
	    px = p.x ;
	    py = p.y ;
	    g.setXORMode (Color.white) ;
	    g.drawLine (px, py, mx, my) ;
	}
    }
    public void run () {
	while (true) {
	    moveAndShowBalls () ;
	    try {
		Thread.sleep(10, 0) ;
	    } catch (InterruptedException e) {} ;
	}
    }
}
