//
//  CuePointer.java: Ƶѥͥ
// 	JDK 1.1 version
//				ů
//	ΥץϡJDK 1.1 ١ǽ񤫤ƤΤǡ
//	Ť֥饦Ǥϡưޤ
//
import java.awt.* ;
import java.awt.event.*;
import java.lang.Math ;

public class CuePointer extends Component
	implements MouseListener, MouseMotionListener
{
    static final int offset = 2 ;
    int cx, cy ;
    int size ;
    int diam, radius ;
    int xpos, ypos ;
    public CuePointer (int size) {
	super () ;
	this.size = size ;
	diam   = size - 2 * offset ;
	radius = diam/2 ;
	xpos = ypos = size / 2 ;
	cx = offset + radius ;
	cy = offset + radius ;
	setSize (size, size) ;
	setBackground (Color.white) ;
	addMouseListener (this) ;
	addMouseMotionListener (this) ;
    }
    public void paint (Graphics g) {
	g.setPaintMode () ;
	g.setColor (Color.black) ;
	g.fillRect (0, 0, size, size) ;
	g.setColor (Color.white) ;
	g.fillOval (offset, offset, diam, diam) ;
	g.setXORMode (Color.black) ;
	g.drawLine (0, ypos, size, ypos) ;
	g.drawLine (xpos, 0, xpos, size) ;
    }
    public void mouseClicked (MouseEvent e) {}
    public void mouseEntered (MouseEvent e) {}
    public void mouseExited  (MouseEvent e) {}
    public double xRatio () {
	double r = (double)radius ;
	double y = (double)(xpos - cx) ;
	double maxx = Math.sqrt (r * r - y * y) ;
	return -(double)(xpos - cx) / maxx ;
    }
    public double yRatio () {
	double r = (double)radius ;
	double x = (double)(xpos - cx) ;
	double maxy = Math.sqrt (r * r - x * x) ;
	return -(double)(ypos - cy) / (double)maxy ;
    }
    public void mousePressed (MouseEvent e) {
	Point p = calcLimit (e.getX(), e.getY()) ;
	Graphics g = getGraphics () ;

	g.setXORMode (Color.white) ;
	g.drawLine (0, ypos, size, ypos) ;
	g.drawLine (xpos, 0, xpos, size) ;
	xpos = p.x ;
	ypos = p.y ;
	g.drawLine (0, ypos, size, ypos) ;
	g.drawLine (xpos, 0, xpos, size) ;
    }
    public void mouseReleased (MouseEvent e) {}
    public void mouseMoved    (MouseEvent e) {}
    public void mouseDragged  (MouseEvent e) {
	Point p = calcLimit (e.getX(), e.getY()) ;
	Graphics g = getGraphics () ;

	g.setXORMode (Color.white) ;
	g.drawLine (0, ypos, size, ypos) ;
	g.drawLine (xpos, 0, xpos, size) ;
	xpos = p.x ;
	ypos = p.y ;
	g.drawLine (0, ypos, size, ypos) ;
	g.drawLine (xpos, 0, xpos, size) ;
    }
    private Point calcLimit (int x, int y) {
	int rx, ry, rr ;

	rx = x - cx ;
	ry = y - cy ;
	rr = rx * rx + ry * ry ;
	if (rr > radius * radius) {
	    rr = (int)Math.sqrt((double)rr) ;
	    rx = rx * radius / rr + cx ;
	    ry = ry * radius / rr + cy ;
	    return new Point (rx, ry) ;
	} else {
	    return new Point (x, y) ;
	}
    }
}
